<link rel="import" href="chrome://resources/polymer/v1_0/polymer/polymer.html">
<link rel="import" href="chrome://resources/polymer/v1_0/paper-checkbox/paper-checkbox.html">
<link rel="import" href="chrome://resources/polymer/v1_0/paper-styles/paper-styles.html">
<link rel="import" href="chrome://resources/cr_elements/v1_0/cr_input/cr_input.html">
<link rel="import" href="chrome://resources/cr_elements/v1_0/network/cr_onc_types.html">
<link rel="import" href="network_property_list.html">
<link rel="import" href="network_proxy_input.html">
<link rel="import" href="network_proxy_exclusions.html">

<dom-module id="network-proxy">
  <link rel="import" type="css" href="network_proxy.css">
  <template>
    <div id="outer" class="layout vertical flex">
      <!-- TODO(stevenjb): Use cr-dropdown-menu once available. -->
      <div>
        <select id="selectType" on-change="onTypeChange_">
          <template is="dom-repeat" items="[[proxyTypes_]]">
            <option value="[[item]]">[[proxyTypeDesc_(item)]]</option>
          </template>
        </select>
      </div>

      <div hidden$="[[!matches_(proxy.Type, ProxySettingsType.PAC)]]"
          class="layout horizontal">
        <span>Autoconfiguration URL:</span>
        <cr-input no-label-float class="flex" value="{{proxy.PAC}}"
            on-blur="onProxyInputChange_">
        </cr-input>
      </div>

      <div hidden$="[[!matches_(proxy.Type, ProxySettingsType.WPAD)]]"
          class="layout horizontal">
        <span>Web Proxy Auto Discovery URL:</span><span>[[WPAD]]</span>
      </div>

      <div hidden$="[[!matches_(proxy.Type, ProxySettingsType.MANUAL)]]"
          class="layout vertical">
        <paper-checkbox id="useUrl" checked="{{useSameProxy}}">
            Use the same proxy for all protocols
        </paper-checkbox>
        <div hidden$="[[!useSameProxy]]" class="layout vertical">
          <network-proxy-input editable="[[editable]]"
              value="{{proxy.Manual.HTTPProxy}}"
              label="Proxy" on-proxy-change="onProxyInputChange_">
          </network-proxy-input>
        </div>
        <div hidden$="[[useSameProxy]]" class="layout vertical">
          <network-proxy-input editable="[[editable]]"
              value="{{proxy.Manual.HTTPProxy}}"
              label="HTTP Proxy" on-proxy-change="onProxyInputChange_">
          </network-proxy-input>
          <network-proxy-input editable="[[editable]]"
              value="{{proxy.Manual.SecureHTTPProxy}}"
              label="Secure HTTP Proxy" on-proxy-change="onProxyInputChange_">
          </network-proxy-input>
          <network-proxy-input editable="[[editable]]"
              value="{{proxy.Manual.FTPProxy}}"
              label="FTP Proxy" on-proxy-change="onProxyInputChange_">
          </network-proxy-input>
          <network-proxy-input editable="[[editable]]"
              value="{{proxy.Manual.SOCKS}}"
              label="SOCKS host" on-proxy-change="onProxyInputChange_">
          </network-proxy-input>
        </div>

        <span>Do not use the proxy settings for these hosts and domains:</span>
        <network-proxy-exclusions exclusions="{{proxy.ExcludeDomains}}"
             on-proxy-change="onProxyExclusionsChange_">
        </network-proxy-exclusions>
        <div class="layout horizontal baseline">
          <cr-input id="proxyExclusion" class="flex" no-label-float>
          </cr-input>
          <cr-button on-click="onAddProxyExclusion_">
            Add Exception
          </cr-button>
        </div>
      </div>
    </div>
  </template>
  <script src="network_proxy.js"></script>
</dom-module>
